Attribute VB_Name = "modDrawLine"
Option Explicit

Public Sub DrawLine(ByVal y As Long, ByRef p1 As pData, ByRef p2 As pData)
  Dim Off As Long, x As Long, x1 As Long, x2 As Long, ikx As Single
  Dim w As Single, kw As Single, z As Single, kz As Single, fCam As Boolean, fLight As Boolean
  Dim u As Single, v As Single, du As Single, dv As Single
  Dim ui As Long, vi As Long, uf As Single, vf As Single
  Dim k1 As Single, k2 As Single, k3 As Single, k4 As Single, k As Single
  Dim cD As Single, dcD As Single, cS As Single, dcS As Single
  Dim ikLw As Single, kLw As Single, Lz As Single, Lw As Single, Lu As Single, Lv As Single, dLz As Single, dLu As Single, dLv As Single
  Dim fog1 As Single, fog2 As Single
  Dim Dfog As Single, fog As Single, ifog As Single
  Dim ccB As Single, ccG As Single, ccR As Single, ccF As Boolean
  x1 = p1.x: x2 = p2.x
  If x1 >= x2 Then Exit Sub
  ikx = 1 / (x2 - x1)
  If x1 <= 0& Then x = 0& Else x = x1
  If x2 > RTWidth Then x2 = RTWidth
  If x >= x2 Then Exit Sub
  kw = (p2.w - p1.w) * ikx
  If Abs(p2.w - p1.w) > MinDWZ Then
    fCam = True
    ikx = 1! / (p2.z - p1.z)
  End If
  Off = y * RTWidth + x
  w = p1.w + (x - x1) * kw
  Select Case Draw
    Case DrawFLTex
      If Abs(p2.Lw - p1.Lw) > MinDWZ Then
        fLight = True
        ikLw = 1! / (p2.Lw - p1.Lw)
      End If
      du = p2.u - p1.u
      dv = p2.v - p1.v
      dcD = p2.cD - p1.cD
      dcS = p2.cS - p1.cS
      dLz = p2.Lz - p1.Lz
      dLu = p2.Lu - p1.Lu
      dLv = p2.Lv - p1.Lv
      fog1 = (p1.w - fogC2) * fogC1
      If fog1 < 0! Then fog1 = 0!
      If fog1 > 1! Then fog1 = 1!
      fog2 = (p2.w - fogC2) * fogC1
      If fog2 < 0! Then fog2 = 0!
      If fog2 > 1! Then fog2 = 1!
      Dfog = fog2 - fog1
      Do
        If WBuffer(Off) < w Then
          If fCam Then
            kz = (1! / w - p1.z) * ikx
          Else
            kz = (x - x1) * ikx
          End If
          u = p1.u + kz * du
          v = p1.v + kz * dv
          fog = fog1 + kz * Dfog
          ifog = 1! - fog
          Lz = p1.Lz + kz * dLz

          Lw = 1! / Lz
          If fLight Then
            kLw = (Lw - p1.Lw) * ikLw
          Else
            kLw = kz
          End If
          Lu = p1.Lu + kLw * dLu
          Lv = p1.Lv + kLw * dLv
          If Lv <= 0! Or Lv >= 255! Or Lu <= 0! Or Lu >= 255! Then
            ccF = False
          Else
            ui = Int(Lu): vi = Int(Lv)
            uf = Lu - ui: vf = Lv - vi
            ui = ui And 255&: vi = vi And 255&
            k = ZBuffer(vi * 256& + ui) * (1! - vf) * (1! - uf) + _
                ZBuffer((vi + 1&) * 256& + ui) * vf * (1! - uf) + _
                ZBuffer(vi * 256& + (ui + 1&)) * (1! - vf) * uf + _
                ZBuffer((vi + 1&) * 256& + (ui + 1&)) * vf * uf - Lz + 0.1!
            If k < 0! Then
              ccF = False
            Else
              If k > 0.1! Then k = 0.1!
              k = k * 10!
              ccF = True
              cD = (p1.cD + kz * dcD) * k
              cS = (p1.cS + kz * dcS) * k
            End If
          End If

          ui = Int(u): vi = Int(v)
          uf = u - ui: vf = v - vi
          ui = ui And TexDS: vi = vi And TexDS
          arColor1 = arTex(vi * TexS + ui)
          arColor2 = arTex(((vi + 1&) And TexDS) * TexS + ui)
          arColor3 = arTex(vi * TexS + ((ui + 1&) And TexDS))
          arColor4 = arTex(((vi + 1&) And TexDS) * TexS + ((ui + 1&) And TexDS))
          k1 = (1! - vf) * (1! - uf)
          k2 = vf * (1! - uf)
          k3 = (1! - vf) * uf
          k4 = vf * uf
          ccB = arB1(0) * k1 + arB2(0) * k2 + arB3(0) * k3 + arB4(0) * k4
          ccG = arB1(1) * k1 + arB2(1) * k2 + arB3(1) * k3 + arB4(1) * k4
          ccR = arB1(2) * k1 + arB2(2) * k2 + arB3(2) * k3 + arB4(2) * k4
          If ccF Then
            ccB = ccB * (cD * Diffuse.b + Ambient.b) + cS * Specular.b
            ccG = ccG * (cD * Diffuse.g + Ambient.g) + cS * Specular.g
            ccR = ccR * (cD * Diffuse.r + Ambient.r) + cS * Specular.r
          Else
            ccB = ccB * Ambient.b
            ccG = ccG * Ambient.g
            ccR = ccR * Ambient.r
          End If
          ccB = ccB * fog + fogB * ifog
          ccG = ccG * fog + fogG * ifog
          ccR = ccR * fog + fogR * ifog
          If ccB >= 255! Then arB0(0) = 255 Else arB0(0) = ccB
          If ccG >= 255! Then arB0(1) = 255 Else arB0(1) = ccG
          If ccR >= 255! Then arB0(2) = 255 Else arB0(2) = ccR

          CBuffer(Off) = arColor0
          WBuffer(Off) = w
        End If
        x = x + 1&
        If x >= x2 Then Exit Sub
        w = w + kw
        Off = Off + 1&
      Loop
    Case DrawToZ
      Do
        z = 1! / w
        If ZBuffer(Off) > z Then ZBuffer(Off) = z
        x = x + 1&
        If x >= x2 Then Exit Sub
        w = w + kw
        Off = Off + 1&
      Loop
  End Select
End Sub
