Attribute VB_Name = "modDrawTri"
Option Explicit

Private Type hData
  iky As Single
  kx As Single
  kw As Single
  du As Single
  dv As Single
  dcD As Single
  dcS As Single
  dLz As Single
  ikLw As Single
  kLu As Single
  kLv As Single
  fCam As Boolean
  fLight As Boolean
End Type

Private Type yData
  y As Long
  yMax As Long
  fLeft As Boolean
  fFirst As Boolean
End Type

Private Sub DrawHTri(vi1 As tData, hd1 As hData, vi2 As tData, hd2 As hData, yD As yData)
  Static p1 As pData, p2 As pData
  Dim ky1 As Single, ky2 As Single, kz1 As Single, kz2 As Single, kLw1 As Single, kLw2 As Single
  If yD.fFirst Or yD.fLeft Then
    ky1 = yD.y - vi1.y
    p1.x = vi1.x + hd1.kx * ky1
    p1.w = vi1.w + hd1.kw * ky1
  End If
  If yD.fFirst Or Not yD.fLeft Then
    ky2 = yD.y - vi2.y
    p2.x = vi2.x + hd2.kx * ky2
    p2.w = vi2.w + hd2.kw * ky2
  End If
  While yD.y < yD.yMax
    p1.z = 1! / p1.w
    If hd1.fCam Then
      kz1 = (p1.z - vi1.z) * hd1.iky
    Else
      kz1 = (yD.y - vi1.y) * hd1.iky
    End If
    p1.u = vi1.u + kz1 * hd1.du
    p1.v = vi1.v + kz1 * hd1.dv
    If Cull = CullCW Then
      p1.cD = -vi1.cD - kz1 * hd1.dcD
      p1.cS = -vi1.cS - kz1 * hd1.dcS
    Else
      p1.cD = vi1.cD + kz1 * hd1.dcD
      p1.cS = vi1.cS + kz1 * hd1.dcS
    End If
    If p1.cD < 0! Then p1.cD = 0!
    If p1.cS < 0! Then p1.cS = 0!
    p1.Lz = vi1.Lz + kz1 * hd1.dLz

    p2.z = 1! / p2.w
    If hd2.fCam Then
      kz2 = (p2.z - vi2.z) * hd2.iky
    Else
      kz2 = (yD.y - vi2.y) * hd2.iky
    End If
    p2.u = vi2.u + kz2 * hd2.du
    p2.v = vi2.v + kz2 * hd2.dv
    If Cull = CullCW Then
      p2.cD = -vi2.cD - kz2 * hd2.dcD
      p2.cS = -vi2.cS - kz2 * hd2.dcS
    Else
      p2.cD = vi2.cD + kz2 * hd2.dcD
      p2.cS = vi2.cS + kz2 * hd2.dcS
    End If
    If p2.cD < 0! Then p2.cD = 0!
    If p2.cS < 0! Then p2.cS = 0!
    p2.Lz = vi2.Lz + kz2 * hd2.dLz

    p1.Lw = 1! / p1.Lz
    If hd1.fLight Then
      kLw1 = p1.Lw - vi1.Lw
    Else
      kLw1 = p1.z - vi1.z
    End If
    p1.Lu = vi1.Lu + kLw1 * hd1.kLu
    p1.Lv = vi1.Lv + kLw1 * hd1.kLv

    p2.Lw = 1! / p2.Lz
    If hd2.fLight Then
      kLw2 = p2.Lw - vi2.Lw
    Else
      kLw2 = p2.z - vi2.z
    End If
    p2.Lu = vi2.Lu + kLw2 * hd2.kLu
    p2.Lv = vi2.Lv + kLw2 * hd2.kLv

    DrawLine yD.y, p1, p2
    p1.x = p1.x + hd1.kx
    p1.w = p1.w + hd1.kw
    p2.x = p2.x + hd2.kx
    p2.w = p2.w + hd2.kw
    yD.y = yD.y + 1&
  Wend
End Sub

Private Sub CalcHData(vi1 As tData, vi2 As tData, hd As hData)
  hd.iky = 1 / (vi2.y - vi1.y)
  hd.kx = (vi2.x - vi1.x) * hd.iky
  hd.kw = (vi2.w - vi1.w) * hd.iky
  If Abs(vi2.w - vi1.w) > MinDWZ Then hd.iky = 1! / (vi2.z - vi1.z): hd.fCam = True Else hd.fCam = False
  hd.du = vi2.u - vi1.u
  hd.dv = vi2.v - vi1.v
  hd.dcD = vi2.cD - vi1.cD
  hd.dcS = vi2.cS - vi1.cS
  hd.dLz = vi2.Lz - vi1.Lz
  If Abs(vi2.Lw - vi1.Lw) > MinDWZ Then hd.ikLw = 1! / (vi2.Lw - vi1.Lw): hd.fLight = True Else hd.ikLw = hd.iky: hd.fLight = False
  hd.kLu = (vi2.Lu - vi1.Lu) * hd.ikLw
  hd.kLv = (vi2.Lv - vi1.Lv) * hd.ikLw
End Sub

Public Sub DrawTriangle(ByRef v() As tData, ByVal i1 As Long, ByVal i2 As Long, ByVal i3 As Long)
  Dim i As Long, hd1 As hData, hd2 As hData, yD As yData
  If Cull = CullCW Then
    If (v(i1).x - v(i3).x) * (v(i2).y - v(i3).y) <= (v(i1).y - v(i3).y) * (v(i2).x - v(i3).x) Then Exit Sub
  ElseIf Cull = CullCCW Then
    If (v(i1).x - v(i3).x) * (v(i2).y - v(i3).y) >= (v(i1).y - v(i3).y) * (v(i2).x - v(i3).x) Then Exit Sub
  End If

  If v(i1).y < v(i2).y Then
    If v(i3).y < v(i1).y Then
      i = i3: i3 = i1: i1 = i
    End If
  Else
    If v(i3).y < v(i2).y Then
      i = i3: i3 = i1: i1 = i
    Else
      i = i2: i2 = i1: i1 = i
    End If
  End If
  If v(i3).y < v(i2).y Then
    i = i3: i3 = i2: i2 = i
  End If

  If v(i3).y <= 0 Then Exit Sub
  If v(i1).y >= RTHeight Then Exit Sub
  If v(i3).y <= v(i1).y Then Exit Sub

  If (v(i3).x - v(i1).x) * (v(i2).y - v(i1).y) < (v(i3).y - v(i1).y) * (v(i2).x - v(i1).x) Then yD.fLeft = False Else yD.fLeft = True

  CalcHData v(i1), v(i3), hd2
  If v(i1).y <= 0 Then yD.y = 0 Else yD.y = v(i1).y
  If v(i2).y >= RTHeight Then yD.yMax = RTHeight Else yD.yMax = v(i2).y
  yD.fFirst = True
  If yD.y < yD.yMax Then
    CalcHData v(i1), v(i2), hd1
    If yD.fLeft Then
      DrawHTri v(i1), hd1, v(i1), hd2, yD
    Else
      DrawHTri v(i1), hd2, v(i1), hd1, yD
    End If
    yD.fFirst = False
  End If
  If v(i2).y <= 0 Then yD.y = 0
  If v(i3).y >= RTHeight Then yD.yMax = RTHeight Else yD.yMax = v(i3).y
  If yD.y < yD.yMax Then
    CalcHData v(i2), v(i3), hd1
    If yD.fLeft Then
      DrawHTri v(i2), hd1, v(i1), hd2, yD
    Else
      DrawHTri v(i1), hd2, v(i2), hd1, yD
    End If
  End If
End Sub
