Attribute VB_Name = "modTex"
Option Explicit

Public arB0(3) As Byte, arColor0 As Long
Public arB1(3) As Byte, arColor1 As Long
Public arB2(3) As Byte, arColor2 As Long
Public arB3(3) As Byte, arColor3 As Long
Public arB4(3) As Byte, arColor4 As Long

Private Old0 As Long, Old1 As Long, Old2 As Long, Old3 As Long, Old4 As Long

Private Declare Function GetMem4 Lib "msvbvm60" (ByVal pSrc As Long, ByVal pDst As Long) As Long
Private Declare Function PutMem4 Lib "msvbvm60" (ByVal pDst As Long, ByVal NewValue As Long) As Long
Private Declare Function ArrPtr Lib "msvbvm60" Alias "VarPtr" (Arr() As Any) As Long

Private Type GdiplusStartupInput
  GdiplusVersion As Long
  DebugEventCallback As Long
  SuppressBackgroundThread As Long
  SuppressExternalCodecs As Long
End Type

Public Type BitmapData
  Width As Long
  Height As Long
  Stride As Long
  PixelFormat As Long
  scan0 As Long
  Reserved As Long
End Type

Public Type RECTL
  Left As Long
  Top As Long
  Right As Long
  Bottom As Long
End Type

Public Enum ImageLockMode
  ImageLockModeRead = &H1
  ImageLockModeWrite = &H2
  ImageLockModeUserInputBuf = &H4
End Enum

Private Const PixelFormat1bppIndexed = &H30101
Private Const PixelFormat4bppIndexed = &H30402
Private Const PixelFormat8bppIndexed = &H30803
Private Const PixelFormat16bppGreyScale = &H101004
Private Const PixelFormat16bppRGB555 = &H21005
Private Const PixelFormat16bppRGB565 = &H21006
Private Const PixelFormat16bppARGB1555 = &H61007
Private Const PixelFormat24bppRGB = &H21808
Private Const PixelFormat32bppRGB = &H22009
Private Const PixelFormat32bppARGB = &H26200A

Private Declare Function GdiplusStartup Lib "gdiplus" (token As Long, inputbuf As GdiplusStartupInput, Optional ByVal outputbuf As Long = 0) As Long
Private Declare Function GdipCreateBitmapFromFile Lib "gdiplus" (ByVal FileName As Long, Bitmap As Long) As Long
Private Declare Function GdipDisposeImage Lib "gdiplus" (ByVal Image As Long) As Long
Private Declare Sub GdiplusShutdown Lib "gdiplus" (ByVal token As Long)
Private Declare Function GdipBitmapLockBits Lib "gdiplus" (ByVal Bitmap As Long, Rect As RECTL, ByVal Flags As ImageLockMode, ByVal PixelFormat As Long, lockedBitmapData As BitmapData) As Long
Private Declare Function GdipBitmapUnlockBits Lib "gdiplus" (ByVal Bitmap As Long, lockedBitmapData As BitmapData) As Long
Private Declare Function GdipGetImageWidth Lib "gdiplus" (ByVal Image As Long, Width As Long) As Long
Private Declare Function GdipGetImageHeight Lib "gdiplus" (ByVal Image As Long, Height As Long) As Long

Public Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (Destination As Any, Source As Any, ByVal Length As Long)

Public arTex() As Long
Public Const TexS As Long = 256, TexDS As Long = 255

Public Sub CreateTextures()
  GDIPLoadPicture App.Path & "\01.jpg", arTex
End Sub

Private Function GDIPLoadPicture(fName As String, ar() As Long) As Boolean
  Dim Res As Long
  Dim tSI As GdiplusStartupInput
  Dim GDIP As Long
  Dim Bmp As Long
  Dim lData As BitmapData
  Dim r As RECTL
  Dim x As Long, y As Long
  
  tSI.GdiplusVersion = 1
  Res = GdiplusStartup(GDIP, tSI)
  If Res = 0 Then
    Res = GdipCreateBitmapFromFile(StrPtr(fName), Bmp)
    If Res = 0 Then
      GdipGetImageWidth Bmp, x
      GdipGetImageHeight Bmp, y
      r.Left = 0
      r.Right = x
      r.Top = 0
      r.Bottom = y
      Res = GdipBitmapLockBits(Bmp, r, ImageLockModeRead, PixelFormat32bppARGB, lData)
      If Res = 0 Then
        ReDim ar(x * y - 1)
        CopyMemory ar(0), ByVal lData.scan0, x * y * 4
        GDIPLoadPicture = True
        GdipBitmapUnlockBits Bmp, lData
      End If
      GdipDisposeImage Bmp
    End If
    GdiplusShutdown GDIP
  End If
End Function

Public Sub ArrInit()
Dim a As Long
  a = ArrPtr(arB0())
  GetMem4 ArrPtr(arB0), VarPtr(a)
  GetMem4 a + 12, VarPtr(Old0)
  PutMem4 a + 12, VarPtr(arColor0)
  a = ArrPtr(arB1())
  GetMem4 ArrPtr(arB1), VarPtr(a)
  GetMem4 a + 12, VarPtr(Old1)
  PutMem4 a + 12, VarPtr(arColor1)
  a = ArrPtr(arB2())
  GetMem4 ArrPtr(arB2), VarPtr(a)
  GetMem4 a + 12, VarPtr(Old2)
  PutMem4 a + 12, VarPtr(arColor2)
  a = ArrPtr(arB3())
  GetMem4 ArrPtr(arB3), VarPtr(a)
  GetMem4 a + 12, VarPtr(Old3)
  PutMem4 a + 12, VarPtr(arColor3)
  a = ArrPtr(arB4())
  GetMem4 ArrPtr(arB4), VarPtr(a)
  GetMem4 a + 12, VarPtr(Old4)
  PutMem4 a + 12, VarPtr(arColor4)
End Sub

Public Sub ArrTerminate()
Dim a As Long
  a = ArrPtr(arB0())
  PutMem4 a + 12, Old0
  a = ArrPtr(arB1())
  PutMem4 a + 12, Old1
  a = ArrPtr(arB2())
  PutMem4 a + 12, Old2
  a = ArrPtr(arB3())
  PutMem4 a + 12, Old3
  a = ArrPtr(arB4())
  PutMem4 a + 12, Old4
End Sub
